
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class School_statisticsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const school_statistics = await db.school_statistics.create(
            {
                id: data.id || undefined,
        
        student_count: data.student_count
        ||
        null
            ,
            
        teacher_count: data.teacher_count
        ||
        null
            ,
            
        pass_rate: data.pass_rate
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await school_statistics.setSchool_year( data.school_year || null, {
            transaction,
        });
        

        

        

        return school_statistics;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const school_statisticsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                student_count: item.student_count
            ||
            null
            ,
            
                teacher_count: item.teacher_count
            ||
            null
            ,
            
                pass_rate: item.pass_rate
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const school_statistics = await db.school_statistics.bulkCreate(school_statisticsData, { transaction });

        // For each item created, replace relation files
        

        return school_statistics;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const school_statistics = await db.school_statistics.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.student_count !== undefined) updatePayload.student_count = data.student_count;
        
        
        if (data.teacher_count !== undefined) updatePayload.teacher_count = data.teacher_count;
        
        
        if (data.pass_rate !== undefined) updatePayload.pass_rate = data.pass_rate;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await school_statistics.update(updatePayload, {transaction});

        
        
        if (data.school_year !== undefined) {
            await school_statistics.setSchool_year(
              
              data.school_year,
              
              { transaction }
            );
        }
        

        
        

        

        return school_statistics;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const school_statistics = await db.school_statistics.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of school_statistics) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of school_statistics) {
                await record.destroy({transaction});
            }
        });


        return school_statistics;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const school_statistics = await db.school_statistics.findByPk(id, options);

        await school_statistics.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await school_statistics.destroy({
            transaction
        });

        return school_statistics;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const school_statistics = await db.school_statistics.findOne(
            { where },
            { transaction },
        );

        if (!school_statistics) {
            return school_statistics;
        }

        const output = school_statistics.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.school_year = await school_statistics.getSchool_year({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.school_years,
        as: 'school_year',
        
        where: filter.school_year ? {
          [Op.or]: [
            { id: { [Op.in]: filter.school_year.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.school_year.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'school_statistics',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.student_countRange) {
                const [start, end] = filter.student_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    student_count: {
                    ...where.student_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    student_count: {
                    ...where.student_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.teacher_countRange) {
                const [start, end] = filter.teacher_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    teacher_count: {
                    ...where.teacher_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    teacher_count: {
                    ...where.teacher_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.pass_rateRange) {
                const [start, end] = filter.pass_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    pass_rate: {
                    ...where.pass_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    pass_rate: {
                    ...where.pass_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.school_statistics.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'school_statistics',
                        'notes',
                        query,
                    ),
                ],
            };
        }

        const records = await db.school_statistics.findAll({
            attributes: [ 'id', 'notes' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['notes', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.notes,
        }));
    }

    
};

